---
name: Library-specific Bug Report
about: Report a problem with this library that needs to be fixed.
title: ''
labels: bug, triage
assignees: ''

---

<!-- PLEASE READ
This form is for bug reports specific to this library.

For troubleshooting tips, see: https://developers.google.com/google-ads/api/docs/best-practices/troubleshooting.

For issues that are related to the Google Ads API itself and not specific to this library, please reach out to one of our support channels: https://developers.google.com/google-ads/api/support.

Please check existing issues to see if your bug has already been reported before creating a new issue. We encourage you to add any relevant information to the existing issue if one already exists.
-->

[DO NOT INCLUDE ANY PERSONAL OR SENSITIVE DATA - MAKE SURE TO REDACT CONTENT WHEN NECESSARY]

**Your client library and Google Ads API versions:**

* Client library version: `vX.Y.Z`

<!-- This should be a released version, see https://github.com/googleads/google-ads-php/releases. -->

* Google Ads API version: `VX`

<!-- You can determine it from the namespace of your `GoogleAdsClient`, e.g., `Google\Ads\GoogleAds\Lib\V6\GoogleAdsClient`. -->

**Your environment:**

<!--
You can paste the output generated by our complementary script: https://github.com/googleads/google-ads-php/blob/master/scripts/print_php_information.php.

Alternatively, please provide with the following pieces of information:

* The PHP version: Run `php -v`.
* The name and version of the operating system: Run `php -r 'print php_uname();'`.
* Whether the PHP Extension `protobuf` is used or not: Run `php -r 'print phpversion("protobuf");'`.
* Whether the PHP Extension `grpc` is used or not: Run `php -r 'print phpversion("grpc");'`.
* The type of transport being used (`grpc` or `rest`): See https://developers.google.com/google-ads/api/docs/client-libs/php/transport.
-->

**Description of the bug:**

**Steps to reproduce:**

**Expected behavior:**

**Request/Response Logs:**

<!--
To enable logging see this page: https://developers.google.com/google-ads/api/docs/client-libs/php/logging.

NOTE: Make sure to include Request IDs when possible.
-->
 
**Anything else we should know about your project / environment:**
