<?php
# Generated by the protocol buffer compiler.  DO NOT EDIT!
# source: google/ads/googleads/v14/services/audience_insights_service.proto

namespace Google\Ads\GoogleAds\V14\Services;

use Google\Protobuf\Internal\GPBType;
use Google\Protobuf\Internal\RepeatedField;
use Google\Protobuf\Internal\GPBUtil;

/**
 * Metadata associated with a Dynamic Lineup attribute.
 *
 * Generated from protobuf message <code>google.ads.googleads.v14.services.DynamicLineupAttributeMetadata</code>
 */
class DynamicLineupAttributeMetadata extends \Google\Protobuf\Internal\Message
{
    /**
     * The national market associated with the lineup.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v14.common.LocationInfo inventory_country = 1;</code>
     */
    protected $inventory_country = null;
    /**
     * The median number of impressions per month on this lineup.
     *
     * Generated from protobuf field <code>optional int64 median_monthly_inventory = 2;</code>
     */
    protected $median_monthly_inventory = null;
    /**
     * The lower end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_lower_bound = 3;</code>
     */
    protected $channel_count_lower_bound = null;
    /**
     * The upper end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_upper_bound = 4;</code>
     */
    protected $channel_count_upper_bound = null;
    /**
     * Examples of channels that are included in the lineup.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v14.services.DynamicLineupAttributeMetadata.SampleChannel sample_channels = 5;</code>
     */
    private $sample_channels;

    /**
     * Constructor.
     *
     * @param array $data {
     *     Optional. Data for populating the Message object.
     *
     *     @type \Google\Ads\GoogleAds\V14\Common\LocationInfo $inventory_country
     *           The national market associated with the lineup.
     *     @type int|string $median_monthly_inventory
     *           The median number of impressions per month on this lineup.
     *     @type int|string $channel_count_lower_bound
     *           The lower end of a range containing the number of channels in the lineup.
     *     @type int|string $channel_count_upper_bound
     *           The upper end of a range containing the number of channels in the lineup.
     *     @type array<\Google\Ads\GoogleAds\V14\Services\DynamicLineupAttributeMetadata\SampleChannel>|\Google\Protobuf\Internal\RepeatedField $sample_channels
     *           Examples of channels that are included in the lineup.
     * }
     */
    public function __construct($data = NULL) {
        \GPBMetadata\Google\Ads\GoogleAds\V14\Services\AudienceInsightsService::initOnce();
        parent::__construct($data);
    }

    /**
     * The national market associated with the lineup.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v14.common.LocationInfo inventory_country = 1;</code>
     * @return \Google\Ads\GoogleAds\V14\Common\LocationInfo|null
     */
    public function getInventoryCountry()
    {
        return $this->inventory_country;
    }

    public function hasInventoryCountry()
    {
        return isset($this->inventory_country);
    }

    public function clearInventoryCountry()
    {
        unset($this->inventory_country);
    }

    /**
     * The national market associated with the lineup.
     *
     * Generated from protobuf field <code>.google.ads.googleads.v14.common.LocationInfo inventory_country = 1;</code>
     * @param \Google\Ads\GoogleAds\V14\Common\LocationInfo $var
     * @return $this
     */
    public function setInventoryCountry($var)
    {
        GPBUtil::checkMessage($var, \Google\Ads\GoogleAds\V14\Common\LocationInfo::class);
        $this->inventory_country = $var;

        return $this;
    }

    /**
     * The median number of impressions per month on this lineup.
     *
     * Generated from protobuf field <code>optional int64 median_monthly_inventory = 2;</code>
     * @return int|string
     */
    public function getMedianMonthlyInventory()
    {
        return isset($this->median_monthly_inventory) ? $this->median_monthly_inventory : 0;
    }

    public function hasMedianMonthlyInventory()
    {
        return isset($this->median_monthly_inventory);
    }

    public function clearMedianMonthlyInventory()
    {
        unset($this->median_monthly_inventory);
    }

    /**
     * The median number of impressions per month on this lineup.
     *
     * Generated from protobuf field <code>optional int64 median_monthly_inventory = 2;</code>
     * @param int|string $var
     * @return $this
     */
    public function setMedianMonthlyInventory($var)
    {
        GPBUtil::checkInt64($var);
        $this->median_monthly_inventory = $var;

        return $this;
    }

    /**
     * The lower end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_lower_bound = 3;</code>
     * @return int|string
     */
    public function getChannelCountLowerBound()
    {
        return isset($this->channel_count_lower_bound) ? $this->channel_count_lower_bound : 0;
    }

    public function hasChannelCountLowerBound()
    {
        return isset($this->channel_count_lower_bound);
    }

    public function clearChannelCountLowerBound()
    {
        unset($this->channel_count_lower_bound);
    }

    /**
     * The lower end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_lower_bound = 3;</code>
     * @param int|string $var
     * @return $this
     */
    public function setChannelCountLowerBound($var)
    {
        GPBUtil::checkInt64($var);
        $this->channel_count_lower_bound = $var;

        return $this;
    }

    /**
     * The upper end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_upper_bound = 4;</code>
     * @return int|string
     */
    public function getChannelCountUpperBound()
    {
        return isset($this->channel_count_upper_bound) ? $this->channel_count_upper_bound : 0;
    }

    public function hasChannelCountUpperBound()
    {
        return isset($this->channel_count_upper_bound);
    }

    public function clearChannelCountUpperBound()
    {
        unset($this->channel_count_upper_bound);
    }

    /**
     * The upper end of a range containing the number of channels in the lineup.
     *
     * Generated from protobuf field <code>optional int64 channel_count_upper_bound = 4;</code>
     * @param int|string $var
     * @return $this
     */
    public function setChannelCountUpperBound($var)
    {
        GPBUtil::checkInt64($var);
        $this->channel_count_upper_bound = $var;

        return $this;
    }

    /**
     * Examples of channels that are included in the lineup.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v14.services.DynamicLineupAttributeMetadata.SampleChannel sample_channels = 5;</code>
     * @return \Google\Protobuf\Internal\RepeatedField
     */
    public function getSampleChannels()
    {
        return $this->sample_channels;
    }

    /**
     * Examples of channels that are included in the lineup.
     *
     * Generated from protobuf field <code>repeated .google.ads.googleads.v14.services.DynamicLineupAttributeMetadata.SampleChannel sample_channels = 5;</code>
     * @param array<\Google\Ads\GoogleAds\V14\Services\DynamicLineupAttributeMetadata\SampleChannel>|\Google\Protobuf\Internal\RepeatedField $var
     * @return $this
     */
    public function setSampleChannels($var)
    {
        $arr = GPBUtil::checkRepeatedField($var, \Google\Protobuf\Internal\GPBType::MESSAGE, \Google\Ads\GoogleAds\V14\Services\DynamicLineupAttributeMetadata\SampleChannel::class);
        $this->sample_channels = $arr;

        return $this;
    }

}

